Code

builtin-remote: Fix missing newline at end of listing of pushed branches
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git-am [options] <mbox>|<Maildir>...
9 git-am [options] --resolved
10 git-am [options] --skip
11 --
12 d,dotest=       (removed -- do not use)
13 i,interactive   run interactively
14 b,binary        pass --allo-binary-replacement to git-apply
15 3,3way          allow fall back on 3way merging if needed
16 s,signoff       add a Signed-off-by line to the commit message
17 u,utf8          recode into utf8 (default)
18 k,keep          pass -k flag to git-mailinfo
19 whitespace=     pass it through git-apply
20 C=              pass it through git-apply
21 p=              pass it through git-apply
22 resolvemsg=     override error message when patch failure occurs
23 r,resolved      to be used after a patch failure
24 skip            skip the current patch
25 rebasing        (internal use for git-rebase)"
27 . git-sh-setup
28 prefix=$(git rev-parse --show-prefix)
29 set_reflog_action am
30 require_work_tree
31 cd_to_toplevel
33 git var GIT_COMMITTER_IDENT >/dev/null || exit
35 stop_here () {
36     echo "$1" >"$dotest/next"
37     exit 1
38 }
40 stop_here_user_resolve () {
41     if [ -n "$resolvemsg" ]; then
42             printf '%s\n' "$resolvemsg"
43             stop_here $1
44     fi
45     cmdline=$(basename $0)
46     if test '' != "$interactive"
47     then
48         cmdline="$cmdline -i"
49     fi
50     if test '' != "$threeway"
51     then
52         cmdline="$cmdline -3"
53     fi
54     echo "When you have resolved this problem run \"$cmdline --resolved\"."
55     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
57     stop_here $1
58 }
60 go_next () {
61         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
62                 "$dotest/patch" "$dotest/info"
63         echo "$next" >"$dotest/next"
64         this=$next
65 }
67 cannot_fallback () {
68         echo "$1"
69         echo "Cannot fall back to three-way merge."
70         exit 1
71 }
73 fall_back_3way () {
74     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
76     rm -fr "$dotest"/patch-merge-*
77     mkdir "$dotest/patch-merge-tmp-dir"
79     # First see if the patch records the index info that we can use.
80     git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
81         "$dotest/patch" &&
82     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
83     git write-tree >"$dotest/patch-merge-base+" ||
84     cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
86     echo Using index info to reconstruct a base tree...
87     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
88         git apply $binary --cached <"$dotest/patch"
89     then
90         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
91         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
92     else
93         cannot_fallback "Did you hand edit your patch?
94 It does not apply to blobs recorded in its index."
95     fi
97     test -f "$dotest/patch-merge-index" &&
98     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
99     orig_tree=$(cat "$dotest/patch-merge-base") &&
100     rm -fr "$dotest"/patch-merge-* || exit 1
102     echo Falling back to patching base and 3-way merge...
104     # This is not so wrong.  Depending on which base we picked,
105     # orig_tree may be wildly different from ours, but his_tree
106     # has the same set of wildly different changes in parts the
107     # patch did not touch, so recursive ends up canceling them,
108     # saying that we reverted all those changes.
110     eval GITHEAD_$his_tree='"$SUBJECT"'
111     export GITHEAD_$his_tree
112     git-merge-recursive $orig_tree -- HEAD $his_tree || {
113             git rerere
114             echo Failed to merge in the changes.
115             exit 1
116     }
117     unset GITHEAD_$his_tree
120 reread_subject () {
121         git stripspace <"$1" | sed -e 1q
124 prec=4
125 dotest=".dotest"
126 sign= utf8=t keep= skip= interactive= resolved= binary= rebasing=
127 resolvemsg= resume=
128 git_apply_opt=
130 while test $# != 0
131 do
132         case "$1" in
133         -i|--interactive)
134                 interactive=t ;;
135         -b|--binary)
136                 binary=t ;;
137         -3|--3way)
138                 threeway=t ;;
139         -s|--signoff)
140                 sign=t ;;
141         -u|--utf8)
142                 utf8=t ;; # this is now default
143         --no-utf8)
144                 utf8= ;;
145         -k|--keep)
146                 keep=t ;;
147         -r|--resolved)
148                 resolved=t ;;
149         --skip)
150                 skip=t ;;
151         --rebasing)
152                 rebasing=t threeway=t keep=t binary=t ;;
153         -d|--dotest)
154                 die "-d option is no longer supported.  Do not use."
155                 ;;
156         --resolvemsg)
157                 shift; resolvemsg=$1 ;;
158         --whitespace)
159                 git_apply_opt="$git_apply_opt $1=$2"; shift ;;
160         -C|-p)
161                 git_apply_opt="$git_apply_opt $1$2"; shift ;;
162         --)
163                 shift; break ;;
164         *)
165                 usage ;;
166         esac
167         shift
168 done
170 # If the dotest directory exists, but we have finished applying all the
171 # patches in them, clear it out.
172 if test -d "$dotest" &&
173    last=$(cat "$dotest/last") &&
174    next=$(cat "$dotest/next") &&
175    test $# != 0 &&
176    test "$next" -gt "$last"
177 then
178    rm -fr "$dotest"
179 fi
181 if test -d "$dotest"
182 then
183         case "$#,$skip$resolved" in
184         0,*t*)
185                 # Explicit resume command and we do not have file, so
186                 # we are happy.
187                 : ;;
188         0,)
189                 # No file input but without resume parameters; catch
190                 # user error to feed us a patch from standard input
191                 # when there is already $dotest.  This is somewhat
192                 # unreliable -- stdin could be /dev/null for example
193                 # and the caller did not intend to feed us a patch but
194                 # wanted to continue unattended.
195                 tty -s
196                 ;;
197         *)
198                 false
199                 ;;
200         esac ||
201         die "previous dotest directory $dotest still exists but mbox given."
202         resume=yes
203 else
204         # Make sure we are not given --skip nor --resolved
205         test ",$skip,$resolved," = ,,, ||
206                 die "Resolve operation not in progress, we are not resuming."
208         # Start afresh.
209         mkdir -p "$dotest" || exit
211         if test -n "$prefix" && test $# != 0
212         then
213                 first=t
214                 for arg
215                 do
216                         test -n "$first" && {
217                                 set x
218                                 first=
219                         }
220                         case "$arg" in
221                         /*)
222                                 set "$@" "$arg" ;;
223                         *)
224                                 set "$@" "$prefix$arg" ;;
225                         esac
226                 done
227                 shift
228         fi
229         git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
230                 rm -fr "$dotest"
231                 exit 1
232         }
234         # -b, -s, -u, -k and --whitespace flags are kept for the
235         # resuming session after a patch failure.
236         # -3 and -i can and must be given when resuming.
237         echo "$binary" >"$dotest/binary"
238         echo " $ws" >"$dotest/whitespace"
239         echo "$sign" >"$dotest/sign"
240         echo "$utf8" >"$dotest/utf8"
241         echo "$keep" >"$dotest/keep"
242         echo 1 >"$dotest/next"
243         if test -n "$rebasing"
244         then
245                 : >"$dotest/rebasing"
246         else
247                 : >"$dotest/applying"
248         fi
249 fi
251 case "$resolved" in
252 '')
253         files=$(git diff-index --cached --name-only HEAD --) || exit
254         if [ "$files" ]; then
255            echo "Dirty index: cannot apply patches (dirty: $files)" >&2
256            exit 1
257         fi
258 esac
260 if test "$(cat "$dotest/binary")" = t
261 then
262         binary=--allow-binary-replacement
263 fi
264 if test "$(cat "$dotest/utf8")" = t
265 then
266         utf8=-u
267 else
268         utf8=-n
269 fi
270 if test "$(cat "$dotest/keep")" = t
271 then
272         keep=-k
273 fi
274 ws=`cat "$dotest/whitespace"`
275 if test "$(cat "$dotest/sign")" = t
276 then
277         SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
278                         s/>.*/>/
279                         s/^/Signed-off-by: /'
280                 `
281 else
282         SIGNOFF=
283 fi
285 last=`cat "$dotest/last"`
286 this=`cat "$dotest/next"`
287 if test "$skip" = t
288 then
289         git rerere clear
290         this=`expr "$this" + 1`
291         resume=
292 fi
294 if test "$this" -gt "$last"
295 then
296         echo Nothing to do.
297         rm -fr "$dotest"
298         exit
299 fi
301 while test "$this" -le "$last"
302 do
303         msgnum=`printf "%0${prec}d" $this`
304         next=`expr "$this" + 1`
305         test -f "$dotest/$msgnum" || {
306                 resume=
307                 go_next
308                 continue
309         }
311         # If we are not resuming, parse and extract the patch information
312         # into separate files:
313         #  - info records the authorship and title
314         #  - msg is the rest of commit log message
315         #  - patch is the patch body.
316         #
317         # When we are resuming, these files are either already prepared
318         # by the user, or the user can tell us to do so by --resolved flag.
319         case "$resume" in
320         '')
321                 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
322                         <"$dotest/$msgnum" >"$dotest/info" ||
323                         stop_here $this
325                 # skip pine's internal folder data
326                 grep '^Author: Mail System Internal Data$' \
327                         <"$dotest"/info >/dev/null &&
328                         go_next && continue
330                 test -s $dotest/patch || {
331                         echo "Patch is empty.  Was it split wrong?"
332                         stop_here $this
333                 }
334                 git stripspace < "$dotest/msg" > "$dotest/msg-clean"
335                 ;;
336         esac
338         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
339         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
340         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
342         if test -z "$GIT_AUTHOR_EMAIL"
343         then
344                 echo "Patch does not have a valid e-mail address."
345                 stop_here $this
346         fi
348         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
350         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
351         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
353         case "$resume" in
354         '')
355             if test '' != "$SIGNOFF"
356             then
357                 LAST_SIGNED_OFF_BY=`
358                     sed -ne '/^Signed-off-by: /p' \
359                     "$dotest/msg-clean" |
360                     sed -ne '$p'
361                 `
362                 ADD_SIGNOFF=`
363                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
364                     test '' = "$LAST_SIGNED_OFF_BY" && echo
365                     echo "$SIGNOFF"
366                 }`
367             else
368                 ADD_SIGNOFF=
369             fi
370             {
371                 printf '%s\n' "$SUBJECT"
372                 if test -s "$dotest/msg-clean"
373                 then
374                         echo
375                         cat "$dotest/msg-clean"
376                 fi
377                 if test '' != "$ADD_SIGNOFF"
378                 then
379                         echo "$ADD_SIGNOFF"
380                 fi
381             } >"$dotest/final-commit"
382             ;;
383         *)
384                 case "$resolved$interactive" in
385                 tt)
386                         # This is used only for interactive view option.
387                         git diff-index -p --cached HEAD -- >"$dotest/patch"
388                         ;;
389                 esac
390         esac
392         resume=
393         if test "$interactive" = t
394         then
395             test -t 0 ||
396             die "cannot be interactive without stdin connected to a terminal."
397             action=again
398             while test "$action" = again
399             do
400                 echo "Commit Body is:"
401                 echo "--------------------------"
402                 cat "$dotest/final-commit"
403                 echo "--------------------------"
404                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
405                 read reply
406                 case "$reply" in
407                 [yY]*) action=yes ;;
408                 [aA]*) action=yes interactive= ;;
409                 [nN]*) action=skip ;;
410                 [eE]*) git_editor "$dotest/final-commit"
411                        SUBJECT=$(reread_subject "$dotest/final-commit")
412                        action=again ;;
413                 [vV]*) action=again
414                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
415                 *)     action=again ;;
416                 esac
417             done
418         else
419             action=yes
420         fi
422         if test $action = skip
423         then
424                 go_next
425                 continue
426         fi
428         if test -x "$GIT_DIR"/hooks/applypatch-msg
429         then
430                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
431                 stop_here $this
432         fi
434         printf 'Applying %s\n' "$SUBJECT"
436         case "$resolved" in
437         '')
438                 git apply $git_apply_opt $binary --index "$dotest/patch"
439                 apply_status=$?
440                 ;;
441         t)
442                 # Resolved means the user did all the hard work, and
443                 # we do not have to do any patch application.  Just
444                 # trust what the user has in the index file and the
445                 # working tree.
446                 resolved=
447                 git diff-index --quiet --cached HEAD -- && {
448                         echo "No changes - did you forget to use 'git add'?"
449                         stop_here_user_resolve $this
450                 }
451                 unmerged=$(git ls-files -u)
452                 if test -n "$unmerged"
453                 then
454                         echo "You still have unmerged paths in your index"
455                         echo "did you forget to use 'git add'?"
456                         stop_here_user_resolve $this
457                 fi
458                 apply_status=0
459                 git rerere
460                 ;;
461         esac
463         if test $apply_status = 1 && test "$threeway" = t
464         then
465                 if (fall_back_3way)
466                 then
467                     # Applying the patch to an earlier tree and merging the
468                     # result may have produced the same tree as ours.
469                     git diff-index --quiet --cached HEAD -- && {
470                         echo No changes -- Patch already applied.
471                         go_next
472                         continue
473                     }
474                     # clear apply_status -- we have successfully merged.
475                     apply_status=0
476                 fi
477         fi
478         if test $apply_status != 0
479         then
480                 echo Patch failed at $msgnum.
481                 stop_here_user_resolve $this
482         fi
484         if test -x "$GIT_DIR"/hooks/pre-applypatch
485         then
486                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
487         fi
489         tree=$(git write-tree) &&
490         parent=$(git rev-parse --verify HEAD) &&
491         commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
492         git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
493         stop_here $this
495         if test -x "$GIT_DIR"/hooks/post-applypatch
496         then
497                 "$GIT_DIR"/hooks/post-applypatch
498         fi
500         go_next
501 done
503 git gc --auto
505 rm -fr "$dotest"